#!/usr/bin/perl -w 

# toggle_hex_AAA_555_8ch_top.pl 

# 9 April 2015

# Check that have the correct number of strings on the input line
if ($#ARGV != 2)
{
	print "Usage:  toggle_hex_AAA_555_8ch_top.pl  <slot> <number of words to read> <output file>\n";
	exit(1);
}

# Setup some variables for items that might change in the future
@ADDRESSES = ("100000","200000","300000","400000","500000","600000","700000","800000","900000","A00000","B00000","C00000","D00000","E00000","F00000","1000000"); # Addresses to read

# Get slot of the board
$SLOT = $ARGV[0];
# Get the number of words to read
$WORDS = $ARGV[1];

# Get the output file name and open a stream to that file
$output = $ARGV[2];
open (TMPFILE, ">v4.out");


### OLD collect_data_v4_16Ch.pl
print "\nRunning initial vme write commands\n";
`./vme7700 write $SLOT 3c 1`;
`./vme7700 write $SLOT 44 1`;
`./vme7700 write $SLOT 48 1`;
`./vme7700 write $SLOT 14 1`;
`./vme7700 write $SLOT 44 1`;
`./vme7700 write $SLOT 48 1`;

# set HP1=0 and write SPI registers

`./vme7700 write $SLOT  1c 010000`;
`./vme7700 write $SLOT  4c 1`;
`./vme7700 write $SLOT  1c 3CBFFC`;
`./vme7700 write $SLOT  4c 1`;
`./vme7700 write $SLOT  1c 3D0000`;
`./vme7700 write $SLOT  4c 1`;
`./vme7700 write $SLOT  1c 3E3FFC`;
`./vme7700 write $SLOT  4c 1`;


`./vme7700 write $SLOT 4 40`;
`./vme7700 write $SLOT 8 1400`;
`./vme7700 write $SLOT c ffff`;
`./vme7700 write $SLOT 10 20`;
`./vme7700 write $SLOT 34 1`;

print "\nRunning initial vme read commands\n";
`./vme7700 read $SLOT 0`;
`./vme7700 read $SLOT 4`;
`./vme7700 read $SLOT 8`;
`./vme7700 read $SLOT c`;
`./vme7700 read $SLOT 10`;

`./vme7700 write $SLOT 3c 0`;

print "\nFinished initial vme read commands\n";

# First step is to prepare the board

`./vme7700 write $SLOT 34 0`;
`sleep 1`;

print "\nRunning vme7700 write $SLOT 3c 1\n";
# Start of runme_bilbo_slot10------------------
`./vme7700 write $SLOT 3c 1`;

print "\nRunning vme7700 read $SLOT 3c\n";
`./vme7700 read $SLOT 3c`;

print "\nReading data from addresses...\n";

$channel = 0;

foreach $address (@ADDRESSES)
{
	# Print address for debug
	print "$address\n";

	# Initialize $i for arrays
	$i = 0;

	# Put all the hexvalues in a variable hexvalues
	@hexvalues = `./vme7700_block read $SLOT $address $WORDS`;
	
	# There are two channels read with each block, so use nextchannel as well as channel
	$nextchannel = $channel + 1;

	foreach $value (@hexvalues)
	{
		# Convert each hex value to dec and break up by channel
		# 001122aa => 0011 is for channel 1, and 22aa is for channel 0
		$hex1=substr($value,0,4);
		$hex2=substr($value,4,4);
		$data[$channel][$i]=hex($hex2);
		$data[$nextchannel][$i]=hex($hex1);
		$i++;
	}
	$channel=$channel+2;
}	

# Write a 0 to 3c and read again
print "Running vme7700 write $SLOT 3c 0\n";
# Start of runme_bilbo_slot10------------------
`./vme7700 write $SLOT 3c 0`;

print "\nRunning vme7700 read $SLOT 3c\n";
`./vme7700 read $SLOT 3c`;

print "\nReset the board";
`./vme7700 write $SLOT 3c 1`;
`./vme7700 write $SLOT 44 1`;
`./vme7700 write $SLOT 3c 0`;

# Write the data array to the output file, remember to increment by 2
print "\nWriting the output file...\n";

for( $j=0; $j<$WORDS; $j++)
{
	for($ch=0; $ch<$channel; $ch++)
	{
		print TMPFILE "$data[$ch][$j]\t";
	}
	print TMPFILE "\n";
}

close TMPFILE;

# Now have a file (v4.out) that looks like this:
# 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150 160 170 180 190 200 210 220 230 240 250 260 270 280 290 300 310 320

## END of old collect_data_v4_16Ch

## START collect_data_v5.pl
# Rearrange above output to look like this:
#
# 10	50		90		130  170  210  250  290
# 20	60		100		140  180  220  260  300
# 30	70		110		150  190  230  270  310
# 40	80		120		160  200  240  280  320

open (TMPFILE, "v4.out");
open (TMPFILE2, ">v5.out");

while ($value=<TMPFILE>)
{
	chop $value;
 	my @a = split(" ",$value);
	print TMPFILE2 "$a[0]\t$a[4]\t$a[8]\t$a[12]\t$a[16]\t$a[20]\t$a[24]\t$a[28]\n";
	print TMPFILE2 "$a[1]\t$a[5]\t$a[9]\t$a[13]\t$a[17]\t$a[21]\t$a[25]\t$a[29]\n";
	print TMPFILE2 "$a[2]\t$a[6]\t$a[10]\t$a[14]\t$a[18]\t$a[22]\t$a[26]\t$a[30]\n";
	print TMPFILE2 "$a[3]\t$a[7]\t$a[11]\t$a[15]\t$a[19]\t$a[23]\t$a[27]\t$a[31]\n";
}	

close TMPFILE;
close TMPFILE2;

## END of collect_data_v5

# Now just output all of these values in hex.

open (TMPFILE2, "v5.out");
open (OUTFILE, ">$output");

while($value = <TMPFILE2>)
{
	chomp $value;  # Delete any carriage returns at the end of the line
	my @array = split(" ", $value); # Split the line read in to an array $array[0]=687, $array[1]=229, etc.
	my $size = @array; # Get the size of @array to use in the next loop statement
	for ($i = 0; $i < $size; $i++) # For each element in @array, do the following:
	{
		my $hex = sprintf("%x", $array[$i]); # Convert the number to binary
		print OUTFILE "$hex "; # Write the value to the output file
	}
	print OUTFILE "\n"; # Write a return to the output value when finish converting all the values on the line
}

close TMPFILE2; # Close the input file
close OUTFILE; # Close the output file
